Index: tools/fuzz-harness.sh |
diff --git a/tools/fuzz-harness.sh b/tools/fuzz-harness.sh |
new file mode 100755 |
index 0000000000000000000000000000000000000000..ebbcd16e36358aad1d8022e214aeddbed875f51c |
--- /dev/null |
+++ b/tools/fuzz-harness.sh |
@@ -0,0 +1,81 @@ |
+#!/bin/bash |
+# Copyright 2012 the V8 project authors. All rights reserved. |
+# Redistribution and use in source and binary forms, with or without |
+# modification, are permitted provided that the following conditions are |
+# met: |
+# |
+# * Redistributions of source code must retain the above copyright |
+# notice, this list of conditions and the following disclaimer. |
+# * Redistributions in binary form must reproduce the above |
+# copyright notice, this list of conditions and the following |
+# disclaimer in the documentation and/or other materials provided |
+# with the distribution. |
+# * Neither the name of Google Inc. nor the names of its |
+# contributors may be used to endorse or promote products derived |
+# from this software without specific prior written permission. |
+# |
+# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS |
+# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT |
+# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR |
+# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT |
+# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, |
+# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT |
+# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, |
+# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY |
+# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT |
+# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE |
+# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. |
+ |
+# A simple harness that downloads and runs 'jsfunfuzz' against debug and |
+# release builds using d8. This takes a long time because it runs many |
+# iterations and is mainly intended for automated usage. The package |
+# containing 'jsfunfuzz' can be found as an attachment to this bug: |
+# https://bugzilla.mozilla.org/show_bug.cgi?id=jsfunfuzz |
+ |
+JSFUNFUZZ_URL="https://bugzilla.mozilla.org/attachment.cgi?id=310631" |
+JSFUNFUZZ_MD5="d0e497201c5cd7bffbb1cdc1574f4e32" |
+ |
+v8_root=$(readlink -f $(dirname $BASH_SOURCE)/../) |
+ |
+jsfunfuzz_file=$v8_root/tools/jsfunfuzz.zip |
Jakob Kummerow
2012/05/22 14:12:01
Please put quotes around any variables containing
Michael Starzinger
2012/05/22 15:04:33
Done.
|
+if [ ! -f $jsfunfuzz_file ]; then |
+ echo "Downloading $jsfunfuzz_file ..." |
+ wget -q -O $jsfunfuzz_file $JSFUNFUZZ_URL || exit 1 |
+fi |
+ |
+jsfunfuzz_sum=$(md5sum $jsfunfuzz_file | awk "{ print \$1 }") |
Jakob Kummerow
2012/05/22 14:12:01
nit: if you use single quotes, you don't need the
Michael Starzinger
2012/05/22 15:04:33
Done.
|
+if [ $jsfunfuzz_sum != $JSFUNFUZZ_MD5 ]; then |
+ echo "Failed to verify checksum!" |
+ exit 1 |
+fi |
+ |
+jsfunfuzz_dir=$v8_root/tools/jsfunfuzz |
+if [ ! -d $jsfunfuzz_dir ]; then |
+ echo "Unpacking into $jsfunfuzz_dir ..." |
+ unzip $jsfunfuzz_file -d $jsfunfuzz_dir || exit 1 |
+fi |
+ |
+flags_debug='--debug-code --expose-gc --verify-gc' |
+flags_release='' |
+ |
+echo "-------------------- DEBUG" |
+python -u $jsfunfuzz_dir/jsfunfuzz/multi_timed_run.py 300 \ |
+ $v8_root/d8_g $flags_debug $jsfunfuzz_dir/jsfunfuzz/jsfunfuzz.js |
Jakob Kummerow
2012/05/22 14:12:01
You want this to work with the GYP build, don't yo
Michael Starzinger
2012/05/22 15:04:33
Done. As discussed offline, I switched the script
|
+exit_debug=$(cat w* | grep " looking good" -c) |
+exit_debug=$((exit_debug-100)) |
+tar -cjf `date +%y%m%d`-debug.tar.bz2 err-* w* |
Jakob Kummerow
2012/05/22 14:12:01
Please use $(...) instead of `...`.
Michael Starzinger
2012/05/22 15:04:33
Done.
|
+rm err-* w* |
Jakob Kummerow
2012/05/22 14:12:01
Might want to use "rm -f" to suppress errors and i
Michael Starzinger
2012/05/22 15:04:33
Done.
|
+echo "Debug failures: $exit_debug" |
+ |
+echo "-------------------- RELEASE" |
+python -u $jsfunfuzz_dir/jsfunfuzz/multi_timed_run.py 300 \ |
+ $v8_root/d8 $flags_release $jsfunfuzz_dir/jsfunfuzz/jsfunfuzz.js |
Jakob Kummerow
2012/05/22 14:12:01
Same request for dynamic/overridable path to d8 he
Michael Starzinger
2012/05/22 15:04:33
Done.
|
+exit_release=$(cat w* | grep " looking good" -c) |
+exit_release=$((exit_release-100)) |
+tar -cjf `date +%y%m%d`-release.tar.bz2 err-* w* |
+rm err-* w* |
+echo "Release failures: $exit_debug" |
Jakob Kummerow
2012/05/22 14:12:01
surely you mean $exit_release.
Michael Starzinger
2012/05/22 15:04:33
Done.
|
+ |
+exit_total=$((exit_release*-1+exit_debug*-1)) |
+echo "Total failures: $exit_total" |
+exit $exit_total |